
#include <iostream>

#include <gmm/gmm.h>

#include <Alignment.h>

int
main (int argc, char* argv[])
{
	/* Ttrue (true transformation matrix)
	 *
	 * 0.3624   0       0.9320    1.0000
	 * 0        1.0000  0         2.0000
	 * -0.9320  0       0.3624    3.0000
	 * 0        0       0         1.0000
	 */
	gmm::dense_matrix<double> X(5,4);
	gmm::dense_matrix<double> U(5,4);

	X(0,0)=0.9501; X(0,1)=0.6154; X(0,2)=0.0579; X(0,3)=1;
	X(1,0)=0.2311; X(1,1)=0.7919; X(1,2)=0.3529; X(1,3)=1;
	X(2,0)=0.6068; X(2,1)=0.9218; X(2,2)=0.8132; X(2,3)=1;
	X(3,0)=0.4860; X(3,1)=0.7382; X(3,2)=0.0099; X(3,3)=1;
	X(4,0)=0.8913; X(4,1)=0.1763; X(4,2)=0.1389; X(4,3)=1;

	U(0,0)=1.3982; U(0,1)=2.6154; U(0,2)=2.1354; U(0,3)=1;
	U(1,0)=1.4126; U(1,1)=2.7919; U(1,2)=2.9124; U(1,3)=1;
	U(2,0)=1.9778; U(2,1)=2.9218; U(2,2)=2.7291; U(2,3)=1;
	U(3,0)=1.1853; U(3,1)=2.7382; U(3,2)=2.5506; U(3,3)=1;
	U(4,0)=1.4524; U(4,1)=2.1763; U(4,2)=2.2196; U(4,3)=1;

	FriGeo::Alignment align (X, U);

	std::vector<double> ind (5);
	double fval = align.FindLeastSquaresAlignment (&ind);

	std::cout << "Total loss: " << fval << std::endl;
	std::cout << "T:" << std::endl << align.T << std::endl;

	std::cout << "Individual losses: " << std::endl;
	for (unsigned int n = 0 ; n < ind.size () ; ++n)
		std::cout << ind[n] << ", ";
	std::cout << std::endl;
}


