
#ifndef	MEXHELP_H
#define	MEXHELP_H

/* mexhelp.h -- Helper functions for converting graphs from/to Matlab
 *   structures.
 */

#include <assert.h>
#include <string.h>
#include <stdlib.h>

#include <iostream>
#include <vector>
#include <map>

#include <mex.h>

#include <Graph.h>

namespace FriGeo
{

class
MexHelp
{
public:
	/* Convert a matlab graph structure to a FriGeo graph object.
	 *
	 * Return true on success, false otherwise.
	 */
	static bool readGraph (const mxArray* graph, FriGeo::Graph& gout);

	/* Convert the graph 'graph' to a matlab structure.
	 */
	static mxArray* writeGraph (const FriGeo::Graph& graph);
};

};

#endif

